<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "prospect".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Prospect".
 *
 * Columns in table "prospect" available as properties of the model,
 * followed by relations of table "prospect" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $source
 * @property integer $account_id
 * @property string $user_comment
 * @property string $status
 * @property string $date_added
 *
 * @property Account $account
 * @property ProspectInput[] $prospectInputs
 * @property ProspectPractice[] $prospectPractices
 * @property ProspectProvider[] $prospectProviders
 * @property ProspectProviderPractice[] $prospectProviderPractices
 * @property SalesAnalysisSetting[] $salesAnalysisSettings
 */
abstract class BaseProspect extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'prospect';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Prospect|Prospects', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('account_id', 'required'),
            array('account_id', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>256),
            array('status', 'length', 'max'=>1),
            array('source, user_comment, date_added', 'safe'),
            array('name, source, user_comment, status, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, source, account_id, user_comment, status, date_added', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'prospectInputs' => array(self::HAS_MANY, 'ProspectInput', 'prospect_id'),
            'prospectPractices' => array(self::HAS_MANY, 'ProspectPractice', 'prospect_id'),
            'prospectProviders' => array(self::HAS_MANY, 'ProspectProvider', 'prospect_id'),
            'prospectProviderPractices' => array(self::HAS_MANY, 'ProspectProviderPractice', 'prospect_id'),
            'salesAnalysisSettings' => array(self::HAS_MANY, 'SalesAnalysisSetting', 'prospect_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'source' => Yii::t('app', 'Source'),
            'account_id' => null,
            'user_comment' => Yii::t('app', 'User Comment'),
            'status' => Yii::t('app', 'Status'),
            'date_added' => Yii::t('app', 'Date Added'),
            'account' => null,
            'prospectInputs' => null,
            'prospectPractices' => null,
            'prospectProviders' => null,
            'prospectProviderPractices' => null,
            'salesAnalysisSettings' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('source', $this->source, true);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('user_comment', $this->user_comment, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
